CodeForces 551 C. GukiZ hates Boxes(二分+贪心)

来源:互联网 发布:编程一个球从100米落下 编辑:程序博客网 时间:2024/05/17 02:38

C. GukiZ hates Boxes
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Professor GukiZ is concerned about making his way to school, because massive piles of boxes are blocking his way.

In total there are n piles of boxes, arranged in a line, from left to right, i-th pile (1 ≤ i ≤ n) containing ai boxes. Luckily, m students are willing to help GukiZ by removing all the boxes from his way. Students are working simultaneously. At time 0, all students are located left of the first pile. It takes one second for every student to move from this position to the first pile, and after that, every student must start performing sequence of two possible operations, each taking one second to complete. Possible operations are:

  1. If i ≠ n, move from pile i to pile i + 1;
  2. If pile located at the position of student is not empty, remove one box from it.

GukiZ's students aren't smart at all, so they need you to tell them how to remove boxes before professor comes (he is very impatient man, and doesn't want to wait). They ask you to calculate minumum time t in seconds for which they can remove all the boxes from GukiZ's way. Note that students can be positioned in any manner after t seconds, but all the boxes must be removed.

Input

The first line contains two integers n and m (1 ≤ n, m ≤ 105), the number of piles of boxes and the number of GukiZ's students.

The second line contains n integers a1, a2, ... an (0 ≤ ai ≤ 109) where ai represents the number of boxes on i-th pile. It's guaranteed that at least one pile of is non-empty.

Output

In a single line, print one number, minimum time needed to remove all the boxes in seconds.

Sample test(s)
input
2 11 1
output
4
input
3 21 0 2
output
5
input
4 1003 4 5 4
output
5
Note

First sample: Student will first move to the first pile (1 second), then remove box from first pile (1 second), then move to the second pile (1 second) and finally remove the box from second pile (1 second).

Second sample: One of optimal solutions is to send one student to remove a box from the first pile and a box from the third pile, and send another student to remove a box from the third pile. Overall, 5 seconds.

Third sample: With a lot of available students, send three of them to remove boxes from the first pile, four of them to remove boxes from the second pile, five of them to remove boxes from the third pile, and four of them to remove boxes from the fourth pile. Process will be over in 5 seconds, when removing the boxes from the last pile is finished.



m个人要去移动n堆盒子  每堆上有若干个盒子  每个人只能进行两种操作 从一个位置走到下一个位置  如果这个位置上的盒子个数不为0  那么就要把这个位置上的盒子移掉  每种操作需要一秒

求这m个人 把盒子全都清掉所花的最少时间 

二分所需要的时间 对每个人进行贪心  从最远的地方开始  让每个人在时间范围内移动更多数目的盒子堆数

#include <cstdio>#include <iostream>#include <cstring>#include <cmath>#include <algorithm>#include <string.h>#include <string>#include <vector>#include <queue>#define MEM(a,x) memset(a,x,sizeof a)#define eps 1e-8#define MOD 10009#define MAXN 100010#define MAXM 100010#define INF 99999999#define ll __int64#define bug cout<<"here"<<endl#define fread freopen("ceshi.txt","r",stdin)#define fwrite freopen("out.txt","w",stdout)using namespace std;int Read(){    char c = getchar();    while (c < '0' || c > '9') c = getchar();    int x = 0;    while (c >= '0' && c <= '9') {        x = x * 10 + c - '0';        c = getchar();    }    return x;}void Print(int a){     if(a>9)         Print(a/10);     putchar(a%10+'0');}ll n,m;ll num[MAXN];int Check(ll x){    ll cnt=m;    ll id=n+1;    ll tmp=0;    while(cnt--)    {        ll y=x;        while(tmp==0)        {            if(id==1) return 1;            tmp=num[--id];        }        if(y<=id) return 0;        y-=id;        while(y>=tmp)        {            y-=tmp;            tmp=0;            while(tmp==0)            {                if(id==1) return 1;                tmp=num[--id];            }        }        tmp-=y;        if(tmp==0&&id==1)            return 1;    }    return 0;}int main(){//    fread;    while(scanf("%I64d%I64d",&n,&m)!=EOF)    {        ll l=1,r=0;        for(ll i=1;i<=n;i++)        {            scanf("%I64d",&num[i]);            r+=(num[i]+i);        }        while(l<r)        {            ll mid=(l+r)/2;            if(Check(mid)) r=mid;            else l=mid+1;        }        printf("%I64d\n",l);    }    return 0;}






0 0
原创粉丝点击